diff -Naur newlib-1.20.0.orig/libgloss/epiphany/unlink.c newlib-1.20.0/libgloss/epiphany/unlink.c
--- newlib-1.20.0.orig/libgloss/epiphany/unlink.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/unlink.c	2012-03-28 10:11:12.220138078 +0200
@@ -0,0 +1,53 @@
+/* EPIPHANY implementation of _unlink ()
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <unistd.h>
+#include <syscall.h>
+
+
+/* ------------------------------------------------------------------------- */
+/*!Remove a file
+
+   Call an assembly function which will generate a system call trap. Either
+   the simulator host file system or the hardware BSP must provide the
+   functionality.
+
+   @param[in] name  Name of file to remove
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+int __attribute__ ((section ("libgloss_epiphany")))
+_unlink (const char *name)
+{
+  return asm_syscall (name, NULL, NULL, SYS_unlink);
+
+
+}	/* _unlink () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/wait.c newlib-1.20.0/libgloss/epiphany/wait.c
--- newlib-1.20.0.orig/libgloss/epiphany/wait.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/wait.c	2012-03-28 10:11:12.220138078 +0200
@@ -0,0 +1,52 @@
+/* EPIPHANY implementation of _wait ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <errno.h>
+#include <sys/types.h>
+
+
+/* ------------------------------------------------------------------------- */
+/*!Wait for a child process
+
+   This is a minimal implementation, which always fails, since we have only
+   one process.
+
+   @param[out] status  Status information about the file waited for.
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+pid_t __attribute__ ((section ("libgloss_epiphany")))
+_wait (int  *status)
+{
+  errno = ENOSYS;
+  return  -1;
+
+}	/* _wait () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/write.c newlib-1.20.0/libgloss/epiphany/write.c
--- newlib-1.20.0.orig/libgloss/epiphany/write.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/write.c	2012-03-28 10:11:12.220138078 +0200
@@ -0,0 +1,52 @@
+/* EPIPHANY implementation of _write ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+#include <sys/types.h>
+#include "epiphany-syscalls.h"
+#include "syscall.h"
+
+
+/* ------------------------------------------------------------------------- */
+/*!Write to a file
+
+  CGEN simulator file output.
+
+   @param[in] fildes  File descriptor to write to
+   @param[in] ptr     Buffer of data to write
+   @param[in] len     Number of bytes to write
+
+   @return  Number of bytes written on success, -1 on failure with an error
+            code in errno.                                                   */
+/* ------------------------------------------------------------------------- */
+ssize_t __attribute__ ((section ("libgloss_epiphany")))
+_write (int file, const void *ptr, size_t len)
+{
+  return asm_write (file, ptr, len);
+}	/* _write () */
diff -Naur newlib-1.20.0.orig/libgloss/hp74x/pa_stub.c newlib-1.20.0/libgloss/hp74x/pa_stub.c
--- newlib-1.20.0.orig/libgloss/hp74x/pa_stub.c	2000-03-17 23:48:50.000000000 +0100
+++ newlib-1.20.0/libgloss/hp74x/pa_stub.c	2012-03-28 10:11:12.221138093 +0200
@@ -2,7 +2,7 @@
 *******************************************************************************
 *
 * File:         pa_stub.c
-* RCS:          $Header: /cvs/src/src/libgloss/hp74x/pa_stub.c,v 1.1 2000/03/17 22:48:50 ranjith Exp $
+* RCS:          $Header$
 * Description:  main routines for PA RISC monitor stub
 * Author:       Robert Quist
 * Created:      Mon Nov  1 10:00:36 1993
diff -Naur newlib-1.20.0.orig/libgloss/iq2000/access.c newlib-1.20.0/libgloss/iq2000/access.c
--- newlib-1.20.0.orig/libgloss/iq2000/access.c	2003-06-06 18:07:57.000000000 +0200
+++ newlib-1.20.0/libgloss/iq2000/access.c	2012-03-28 10:11:12.221138093 +0200
@@ -3,7 +3,7 @@
  * Copyright (C) 1993 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/libgloss/libnosys/configure.in newlib-1.20.0/libgloss/libnosys/configure.in
--- newlib-1.20.0.orig/libgloss/libnosys/configure.in	2011-06-14 15:40:46.000000000 +0200
+++ newlib-1.20.0/libgloss/libnosys/configure.in	2012-03-28 10:11:12.226138171 +0200
@@ -45,9 +45,7 @@
 	;;
   arc-*-*)
 	;;
-  arm-*-pe)
-	;;
-  arm-*-*)
+  arm*-*-*)
 	;;
   bfin-*-*)
 	;;
@@ -142,24 +140,24 @@
         ;;
 esac
 
-AC_CACHE_CHECK([for symbol prefix], libc_symbol_prefix, [dnl
+AC_CACHE_CHECK([for symbol prefix], libc_cv_symbol_prefix, [dnl
 cat > conftest.c <<\EOF
 foo () { }
 EOF
 dnl
-libc_symbol_prefix=none
+libc_cv_symbol_prefix=none
 if AC_TRY_COMMAND([${CC-cc} -S conftest.c -o - | fgrep "\$foo" > /dev/null]);
 then
-  libc_symbol_prefix='$'
+  libc_cv_symbol_prefix='$'
 else
   if AC_TRY_COMMAND([${CC-cc} -S conftest.c -o - | fgrep "_foo" > /dev/null]);
   then
-    libc_symbol_prefix=_
+    libc_cv_symbol_prefix=_
   fi
 fi
 rm -f conftest* ])
-if test $libc_symbol_prefix != none; then
-  AC_DEFINE_UNQUOTED(__SYMBOL_PREFIX, "$libc_symbol_prefix")
+if test $libc_cv_symbol_prefix != none; then
+  AC_DEFINE_UNQUOTED(__SYMBOL_PREFIX, "$libc_cv_symbol_prefix")
 else
   AC_DEFINE(__SYMBOL_PREFIX, "")
 fi
diff -Naur newlib-1.20.0.orig/libgloss/m68k/fido.h newlib-1.20.0/libgloss/m68k/fido.h
--- newlib-1.20.0.orig/libgloss/m68k/fido.h	2006-12-18 22:48:18.000000000 +0100
+++ newlib-1.20.0/libgloss/m68k/fido.h	2012-03-28 10:11:12.227138187 +0200
@@ -11,9 +11,9 @@
  *    Wed, 1 June 2005 David L. Deis [DD]
  *
  *  @par CVS-Info:
- *    $Revision: 1.2 $
- *    $Author: jjohnstn $
- *    $Date: 2006/12/18 21:48:18 $
+ *    $Revision$
+ *    $Author$
+ *    $Date$
  *
  *  @par Description:
  *  Contains board-specific and onchip memory-mapped register and internal
diff -Naur newlib-1.20.0.orig/libgloss/mn10200/access.c newlib-1.20.0/libgloss/mn10200/access.c
--- newlib-1.20.0.orig/libgloss/mn10200/access.c	2001-02-22 23:23:23.000000000 +0100
+++ newlib-1.20.0/libgloss/mn10200/access.c	2012-03-28 10:11:12.227138187 +0200
@@ -3,7 +3,7 @@
  * Copyright (C) 1993 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/libgloss/mn10300/access.c newlib-1.20.0/libgloss/mn10300/access.c
--- newlib-1.20.0.orig/libgloss/mn10300/access.c	2001-02-22 23:23:23.000000000 +0100
+++ newlib-1.20.0/libgloss/mn10300/access.c	2012-03-28 10:11:12.227138187 +0200
@@ -3,7 +3,7 @@
  * Copyright (C) 1993 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/libgloss/mt/access.c newlib-1.20.0/libgloss/mt/access.c
--- newlib-1.20.0.orig/libgloss/mt/access.c	2005-12-12 12:16:41.000000000 +0100
+++ newlib-1.20.0/libgloss/mt/access.c	2012-03-28 10:11:12.228138203 +0200
@@ -3,7 +3,7 @@
  * Copyright (C) 1993 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/libgloss/mt/startup-16-003.S newlib-1.20.0/libgloss/mt/startup-16-003.S
--- newlib-1.20.0.orig/libgloss/mt/startup-16-003.S	2006-03-22 13:47:59.000000000 +0100
+++ newlib-1.20.0/libgloss/mt/startup-16-003.S	2012-03-28 10:11:12.228138203 +0200
@@ -1,5 +1,5 @@
 /*
- * $Header: /cvs/src/src/libgloss/mt/startup-16-003.S,v 1.2 2006/03/22 12:47:59 nathan Exp $
+ * $Header$
  *
  * interrupt_vectors.s -- the interrupt handler jump table. 
  *
diff -Naur newlib-1.20.0.orig/libgloss/mt/startup-64-001.S newlib-1.20.0/libgloss/mt/startup-64-001.S
--- newlib-1.20.0.orig/libgloss/mt/startup-64-001.S	2005-12-12 12:16:41.000000000 +0100
+++ newlib-1.20.0/libgloss/mt/startup-64-001.S	2012-03-28 10:11:12.228138203 +0200
@@ -1,5 +1,5 @@
 /*
- * $Header: /cvs/src/src/libgloss/mt/startup-64-001.S,v 1.1 2005/12/12 11:16:41 nathan Exp $
+ * $Header$
  *
  * interrupt_vectors.s -- the interrupt handler jump table. 
  *
diff -Naur newlib-1.20.0.orig/libgloss/README newlib-1.20.0/libgloss/README
--- newlib-1.20.0.orig/libgloss/README	2010-09-23 00:45:07.000000000 +0200
+++ newlib-1.20.0/libgloss/README	2012-03-28 10:11:12.190137610 +0200
@@ -7,3 +7,4 @@
 pa	- WinBond and Oki boards with a PA.
 mips	- R3000 support. Array Tech LSI33k based RAID disk controller.
 lm32    - Lattice Mico32 simulator.
+epiphany - Adapteva Epiphany multicore processor.
\ No newline at end of file
diff -Naur newlib-1.20.0.orig/libgloss/v850/access.c newlib-1.20.0/libgloss/v850/access.c
--- newlib-1.20.0.orig/libgloss/v850/access.c	2010-07-23 19:52:37.000000000 +0200
+++ newlib-1.20.0/libgloss/v850/access.c	2012-03-28 10:11:12.234138296 +0200
@@ -3,7 +3,7 @@
  * Copyright (C) 1993 DJ Delorie
  * All rights reserved.
  *
- * Redistribution and use in source and binary forms is permitted
+ * Redistribution, modification, and use in source and binary forms is permitted
  * provided that the above copyright notice and following paragraph are
  * duplicated in all such forms.
  *
diff -Naur newlib-1.20.0.orig/newlib/ChangeLog newlib-1.20.0/newlib/ChangeLog
--- newlib-1.20.0.orig/newlib/ChangeLog	2011-12-19 23:03:17.000000000 +0100
+++ newlib-1.20.0/newlib/ChangeLog	2012-03-28 10:11:12.242138421 +0200
@@ -1,3 +1,82 @@
+2012-03-09  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* libc/include/machine/setjmp-dj.h: Modify license to include
+	modification in clause as permitted by DJ Delorie.
+	* libc/machine/arm/access.c: Ditto.
+	* libc/machine/i386/setjmp.S: Ditto.
+	* libc/sys/h8300hms/sys/file.h: Ditto.
+	* libc/sys/linux/machine/i386/setjmp.S: Ditto.
+	* libc/sys/sysmec/access.c: Ditto.
+	* libc/sys/sysnecv850/access.c: Ditto.
+
+2012-03-02  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* libc/posix/readdir_r.c: Fix return code when end of
+	directory is reached.
+
+2012-02-23  Dan Egnor  <egnor@ofb.net>
+
+	* configure.host: Accept "arm*" host spec instead of just "arm".
+
+2012-02-21  Jeremy Bennett  <jeremy.bennett@embecosm.com>
+            Alan Lehotsky  <apl@alum.mit.edu>
+            Joern Rennecke  <joern.rennecke@embecosm.com>
+
+	* configure.host: Add Epiphany support.
+	* libc/include/machine/ieeefp.h: Likewise.
+	* libc/include/machine/setjmp.h: Likewise.
+	* libc/machine/configure.in, libc/sys/configure.in: Likewise.
+	* libc/machine/configure, libc/sys/configure: Regenerate.
+	* libc/machine/epiphany, libc/sys/epiphany: New directories.
+	* NEWS: Mention addition of Epiphany.
+
+2012-02-15  Christopher Faylor  <me.newlib2012@cgf.cx>
+
+	* configure.host: Fix typo: xdir_dir -> xdr_dir.
+
+2012-02-09  Eric Blake  <eblake@redhat.com>
+
+	* libc/include/_ansi.h (_ELIDABLE_INLINE): Fix C99 mode.
+
+2012-02-09  Sebastian Huber <sebastian.huber@embedded-brains.de>
+
+	* libc/sys/rtems/sys/utime.h: Include <sys/types.h> to provide a
+	definition of time_t.
+
+2012-01-13  Yaakov Selkowitz  <yselkowitz@users.sourceforge.net>
+
+	* libc/stdio/sprintf.c: Document 'm' conversion specifier.
+	* libc/stdio/swprintf.c: Ditto.
+	* libc/stdio/vfprintf.c (_VFPRINTF_R) [_GLIBC_EXTENSION]: Handle 'm'
+	conversion specifier.
+	* libc/stdio/vfwprintf.c (_VFWPRINTF_R) [_GLIBC_EXTENSION]: Ditto.
+
+2012-01-12  Yaakov Selkowitz  <yselkowitz@users.sourceforge.net>
+
+	* libc/include/tgmath.h: New header.
+
+2012-01-09  Yaakov Selkowitz  <yselkowitz@users.sourceforge.net>
+
+	* libc/include/sys/unistd.h [__CYGWIN__] (get_current_dir_name):
+	Declare.
+
+2012-01-09  Yaakov Selkowitz  <yselkowitz@users.sourceforge.net>
+
+	* libc/include/complex.h: Fix "/*" within comment warning.
+
+2012-01-09  Corinna Vinschen  <vinschen@redhat.com>
+
+	* libc/include/process.h: Remove Cygwin-only header.
+
+2012-01-03  Viachaslau Kulakouski  <Viachaslau.Kulakouski@oracle.com>
+
+	* libc/stdlib/__atexit.c: Refer to __atexit_lock instead of lock.
+
+2011-12-20  Aleksandr Platonov  <pam@oktetlabs.ru>
+
+	* libc/stdio/fvwrite.c (__sfvwrite_r): Set __SMBF flag to avoid double 
+	free in fclose.  Enhance comment.
+
 2011-12-19  Jeff Johnston  <jjohnstn@redhat.com>
 
 	* NEWS: Update with 1.20.0 info.
@@ -16,14 +95,6 @@
 	* libm/libm.texinfo: Ditto.
 	* libc/sys/linux/shared.ld: Add VERS_1.20
 
-2011-12-13  Richard Earnshaw  <rearnsha@arm.com>
-	    Thomas Klein  <th.r.klein@web.de>
-
-	* libc/sys/arm/crt0.S: Manually set the target architecture
-	when compiling for Thumb1 on EABI targets.
-	Don't use SWI on M-profile cores.
-	Avoid v6-only Thumb-1 MOV instruction.
-
 2011-12-12  Akio Idehara  <zbe64533@gmail.com>
 
 	* libc/time/strftime.c (get_era_info): Fix off-by-one error in month
@@ -48,51 +119,16 @@
 	* libc/iconv/ccs/Makefile.am: Add missing backslash.
 	* libc/iconv/ccs/Makefile.in: Regenerate.
 
-2011-10-18  Dr David Alan Gilbert  <david.gilbert@linaro.org>
-
-	* libc/machine/arm/Makefile.am (lib_a_SOURCES): Add memchr-stub.c,
-	memchr.S.
-	* libc/machine/arm/arm_asm.h: Add ifdef to allow it to be included
-	in .S files.
-	* libc/machine/arm/memchr-stub.c: New file - just selects what to
-	compile.
-	* libc/machine/arm/memchr.S: New file - ARMv6t2/v7 version.
-
-	* libc/machine/arm/Makefile.am (lib_a_SOURCES): Add strlen-armv7.S.
-	* libc/machine/arm/strlen-armv7.S: New file.
-	* libc/machine/arm/strlen.c: Add ifdef optimised code so it isn't
-	for v7 or 6t2.
-
-	* libc/machine/arm/Makefile.in: Regenerate.
-
 2011-10-11  Steven Abner <pheonix@zoomtown.com>
 
 	* libc/time/mktm_r.c: (__tzcalc_limits) Fix Julian day calculation.
 	* libc/time/mktime.c: (mktime) Fix tm_yday, tm_mday updating when
 	timezone causes roll over.
 
-2011-10-10  Nick Clifton  <nickc@redhat.com>
-
-	* libc/sys/arm/crt0.S: Synchronise with libgloss version.
-	* libc/sys/arm/arm.h: Imported from libgloss.
-
 2011-10-04  Greta Yorsh  <Greta.Yorsh@arm.com>
 
 	* testsuite/newlib.string/memcpy-1.c: New test.
 
-2011-10-04  Nick Clifton  <nickc@redhat.com>
-
-	* libc/machine/arm/memcpy.S: Fix unaligned access copying.
-
-2011-09-29  Greta Yorsh  <Greta.Yorsh@arm.com>
-
-	* libc/machine/arm/memcpy.S: New file.  Contains a hand coded
-	memcpy function optimized for the cortex-a15.
-	* libc/machine/arm/memcpy-stub.c: New file.
-	* libc/machine/arm/Makefile.am (lib_a_SOURCES): Add memcpy-stub.c,
-	memcpy.S.
-	* libc/machine/arm/Makefile.in: Regenerate.
-
 2011-09-08  Jeff Johnston  <jjohnstn@redhat.com>
 
 	* testsuite/lib/flags.exp: Add logic to add the
@@ -492,16 +528,6 @@
 	* libm/math/w_tgamma.c: Only build ifndef _DOUBLE_IS_32BITS.
 	* libm/math/wf_tgamma.c: Map tgamma to tgammaf, ifdef _DOUBLE_IS_32BITS.
 
-2011-01-12  Jeff Johnston  <jjohnstn@redhat.com>
-
-	* configure.host: Add noinclude variable to allow specification
-	of header files to remove from installation.
-	* acinclude.m4: Provide NO_INCLUDE_LIST variable based on
-	noinclude variable in configure.host.
-	* configure: Regenerated.
-	* Makefile.am: Remove all header files in NO_INCLUDE_LIST.
-	* Makefile.in: Regenerated.
-
 2011-01-12  Yaakov Selkowitz  <yselkowitz@users.sourceforge.net>
 
 	* libc/sys/linux/sys/signal.h (sig_t): Move from here...
diff -Naur newlib-1.20.0.orig/newlib/ChangeLog.rtems newlib-1.20.0/newlib/ChangeLog.rtems
--- newlib-1.20.0.orig/newlib/ChangeLog.rtems	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/newlib/ChangeLog.rtems	2012-03-28 10:11:12.244138452 +0200
@@ -0,0 +1,150 @@
+2012-03-28	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/inttypes.h: Add preliminary support for GCC's stdint.h.
+
+2011-12-16	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/sys/time.h: Add adjtime.
+	* libc/include/sys/resource.h: Add getrusage.
+
+2011-10-06	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/sys/rtems/machine/_types.h (_ssize_t): Special case __ARM_EABI__.
+
+2011-08-11	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/stdio/tmpnam.c: Use PRIxPTR instead of %x.
+
+2011-08-11	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/search/hcreate_r.c: #ifdef 0 unused vars ie, idx.
+
+2011-04-19  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/include/stdint.h: Rework SIZE_MAX.
+
+2011-02-07  Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/stdlib.h: More ansi-compliance.
+
+2011-02-01  Ralf Corsépius  <ralf.corsepius@rtems.org>
+	
+	* libc/include/stdio.h: More ansi-compliance.
+
+	* libc/include/stdlib.h: Remove atoff.
+	* libc/stdlib/atoff.c: Remove.
+	* libc/stdlib/atof.c: Remove atoff.
+	* libc/stdlib/Makefile.am: Remove atoff.
+	* libc/stdlib/Makefile.in: Regenerate.
+
+	* libc/include/stdio.h: Make fdopen accessible to c99.
+
+2011-01-11  Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/string.h: Remove Cygwin DEFS_H kludge.
+
+2011-01-07	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/stdio/open_memstream.c: Replace 64 * 1024 with 0x10000 to 
+	avoid integer overflow on h8300.
+
+2011-01-05	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/stdio/tmpnam.c: Include <stdint.h>.
+	Use intptr_t instead of _POINTER_INT for improved portability.
+	* libc/misc/__dprintf.c: Include <stdint.h>
+	Use intptr_t instead of _POINTER_INT for improved portability.
+
+2011-01-05	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libm/common/s_round.c: Cast const int to __int32_t.
+
+2011-01-04	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libm/math/e_scalb.c: Include <limits.h>.
+	Don't rely on 65000 being a valid int.
+
+2011-01-04	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/posix/readdir.c:	Include <stdint.h>.
+	Cast to intptr_t instead of int.
+
+2011-01-04	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/string/memccpy.c, libc/string/memchr.c,
+	libc/string/memcmp.c, libc/string/memcpy.c,
+	libc/string/memmove.c, libc/string/mempcpy.c,
+	libc/string/memset.c, libc/string/stpcpy.c,
+	libc/string/stpncpy.c, libc/string/strcpy.c,
+	libc/string/strlen.c, libc/string/strncat.c,
+	libc/string/strncpy.c (UNALIGNED):
+	Include <stdint.h>.
+	Cast to intptr_t instead of long.
+
+2011-01-04	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* Makefile.am: Don't install include/rpc/*.h.
+	* Makefile.in: Regenerate.
+	* libc/Makefile.am: Install include/rpc/xdr.h include/rpc/types.h. 
+	* libc/Makefile.in: Regenerate.
+
+2010-12-31  Ralf Corsepius  <ralf.corsepius@rtems.org>
+
+	* doc/makedoc.c: Add cludge to make makedoc 64bit compliant.
+
+2010-12-30	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/signal.h: Don't provide sighandler_t.
+
+2010-12-29	Ralf Corsépius  <ralf.corsepius@rtems.org>
+
+	* libc/include/sys/dir.h: Remove.
+
+2010-08-10	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	PR 1475/newlib:
+	* libc/include/stdint.h: Fall back to compute SIZE_MAX based on
+	__SIZEOF_SIZE_T__ and __CHAR_BIT__ if available.
+
+2010-08-04	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/string/strcat.c: 
+	Include <stdint.h>. Use uintptr_t instead of long in ALIGNED.
+	* libc/string/strchr.c, libc/string/strcmp.c, libc/string/strncmp.c:
+	Include <stdint.h>. Use uintptr_t instead of long in UNALIGNED.
+
+2010-03-25	Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/include/string.h: Remove bcmp, bcopy, bzero, ffs, index, rindex,
+	strcasecmp, strncasecmp (Moved to strings.h).
+	Remove strcmpi, stricmp, strncmpi, strnicmp.
+
+2009-12-18  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/search/db_local.h:
+	Use __uint32_t instead of u_int (prototype mismatches).
+	* libc/search/extern.h (__buf_init): 
+	Use __uint32_t instead of int (16 bit target portability).
+	* libc/search/hash_buf.c: Use ptrdiff_t instead of __uint32_t,
+	use __uint32_t instead of int (16 bit target portability).
+	* libc/search/hash.h: Use __uint32_it instead of int
+	(16 bit target portability).
+	* libm/common/modfl.c: Add cast to (double*) to avoid GCC warning.
+
+2009-10-29  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/include/inttypes.h: 
+	Rework logic to determine PRI*PTR.
+	Prefer long64 over longlong64.
+	* libc/include/machine/_default_types.h: 
+	Sync logic for __int32 with stdint.h (Prefer long over int).
+	* libc/include/stdint.h:
+	Remove __SPU__ hack.
+	Prefer int for int16_t (sync with _default_types.h).
+	Rework intptr_t determination.
+
+2009-03-09  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* libc/machine/powerpc/times.c: Remove.
+	* libc/machine/powerpc/Makefile.am: Remove times.c.
+	* libc/machine/powerpc/Makefile.in: Regenerate.
diff -Naur newlib-1.20.0.orig/newlib/configure.host newlib-1.20.0/newlib/configure.host
--- newlib-1.20.0.orig/newlib/configure.host	2011-11-29 07:33:48.000000000 +0100
+++ newlib-1.20.0/newlib/configure.host	2012-03-28 10:11:12.246138482 +0200
@@ -46,7 +46,6 @@
 #   crt1_dir            directory where crt1 object is found
 #   have_crt0		"yes"/"no" if crt0 is/isn't provided.
 #			"" if crt0 is provided when sys_dir is set
-#   noinclude		list of include files to not install
 
 newlib_cflags=
 libm_machine_dir=
@@ -59,7 +58,6 @@
 xdr_dir=
 syscall_dir=
 unix_dir=
-noinclude=
 mach_add_setjmp=
 crt1=
 crt1_dir=
@@ -98,7 +96,7 @@
   arc)
 	machine_dir=
 	;;
-  arm)
+  arm*)
 	machine_dir=arm
 	;;
   avr*)
@@ -122,6 +120,9 @@
   d30v*)
 	machine_dir=d30v
 	;;
+  epiphany)
+	machine_dir=epiphany
+	;;
   fido)
 	machine_dir=m68k
 	newlib_cflags="${newlib_cflags} -DCOMPACT_CTYPE"
@@ -364,7 +365,7 @@
   arc-*-*)
 	sys_dir=arc
 	;;
-  arm-*-*)
+  arm*-*-*)
 	sys_dir=arm
 	if [ "x${newlib_may_supply_syscalls}" = "xno" ] ; then
 	  have_crt0="no"
@@ -385,6 +386,11 @@
   d30v*)
 	sys_dir=
 	;;
+  epiphany-*-*)
+	sys_dir=epiphany
+	# crt0 is provided by libgloss.
+	have_crt0="no"
+	;;
   frv*)
         sys_dir=
         ;;
@@ -552,10 +558,10 @@
   arc-*-*)
 	syscall_dir=syscalls
 	;;
-  arm-*-pe)
+  arm*-*-pe)
 	syscall_dir=syscalls
 	;;
-  arm-*-*)
+  arm*-*-*)
 	syscall_dir=syscalls
 # If newlib is supplying syscalls, select which debug protocol is being used.
 # ARM_RDP_MONITOR selects the Demon monitor.
@@ -598,6 +604,10 @@
 	newlib_cflags="${newlib_cflags} -DABORT_MESSAGE -DSMALL_MEMORY -DMISSING_SYSCALL_NAMES"
 	syscall_dir=
 	;;
+  epiphany*)
+	syscall_dir=syscalls
+	newlib_cflags="${newlib_cflags} -DSIGNAL_PROVIDED"
+	;;
   fido-*-elf)
 	newlib_cflags="${newlib_cflags} -DHAVE_RENAME -DHAVE_SYSTEM -DMISSING_SYSCALL_NAMES"
 	syscall_dir=
@@ -787,11 +797,6 @@
 	fi
 fi
 
-# Remove rpc headers if xdr_dir not specified
-if [ "x${xdir_dir}" = "x" ]; then
-	noinclude="${noinclude} rpc/types.h rpc/xdr.h"
-fi
-
 if test -z "${have_crt0}" && test -n "${sys_dir}"; then
   have_crt0="yes"
 fi
diff -Naur newlib-1.20.0.orig/newlib/doc/makedoc.c newlib-1.20.0/newlib/doc/makedoc.c
--- newlib-1.20.0.orig/newlib/doc/makedoc.c	2009-03-25 22:16:04.000000000 +0100
+++ newlib-1.20.0/newlib/doc/makedoc.c	2012-03-28 10:11:12.246138482 +0200
@@ -57,7 +57,7 @@
 {
     char *ptr;
     unsigned int write_idx;
-    unsigned int size;
+    size_t size;
 } string_type;
 
 
@@ -68,7 +68,7 @@
 
 static void DEFUN(init_string_with_size,(buffer, size),
 	   string_type *buffer AND
-	   unsigned int size )
+	   size_t size )
 {
   buffer->write_idx = 0;
   buffer->size = size;
@@ -219,8 +219,8 @@
 stinst_type *pc;
 stinst_type sstack[STACK];
 stinst_type *ssp = &sstack[0];
-int istack[STACK];
-int *isp = &istack[0];
+long istack[STACK];
+long *isp = &istack[0];
 
 typedef int *word_type;
 
@@ -270,7 +270,7 @@
 {
     isp++;
     pc++;
-    *isp = (int)(*pc);
+    *isp = (long)(*pc);
     pc++;
     
 }
diff -Naur newlib-1.20.0.orig/newlib/libc/include/_ansi.h newlib-1.20.0/newlib/libc/include/_ansi.h
--- newlib-1.20.0.orig/newlib/libc/include/_ansi.h	2009-12-17 20:43:43.000000000 +0100
+++ newlib-1.20.0/newlib/libc/include/_ansi.h	2012-03-28 10:11:12.248138513 +0200
@@ -113,21 +113,24 @@
   to emit the function body unless the address is explicitly
   taken.  However this behaviour is changing to match the C99
   standard, which uses 'extern inline' to indicate that the
-  function body *must* be emitted.  If we are using GCC, but do
-  not have the new behaviour, we need to use extern inline; if
-  we are using a new GCC with the C99-compatible behaviour, or
-  a non-GCC compiler (which we will have to hope is C99, since
-  there is no other way to achieve the effect of omitting the
-  function if it isn't referenced) we just use plain 'inline',
-  which c99 defines to mean more-or-less the same as the Gnu C
-  'extern inline'.  */
+  function body *must* be emitted.  Likewise, a function declared
+  without either 'extern' or 'static' defaults to extern linkage
+  (C99 6.2.2p5), and the compiler may choose whether to use the
+  inline version or call the extern linkage version (6.7.4p6).
+  If we are using GCC, but do not have the new behaviour, we need
+  to use extern inline; if we are using a new GCC with the
+  C99-compatible behaviour, or a non-GCC compiler (which we will
+  have to hope is C99, since there is no other way to achieve the
+  effect of omitting the function if it isn't referenced) we use
+  'static inline', which c99 defines to mean more-or-less the same
+  as the Gnu C 'extern inline'.  */
 #if defined(__GNUC__) && !defined(__GNUC_STDC_INLINE__)
 /* We're using GCC, but without the new C99-compatible behaviour.  */
 #define _ELIDABLE_INLINE extern __inline__ _ATTRIBUTE ((__always_inline__))
 #else
-/* We're using GCC in C99 mode, or an unknown compiler which 
+/* We're using GCC in C99 mode, or an unknown compiler which
   we just have to hope obeys the C99 semantics of inline.  */
-#define _ELIDABLE_INLINE __inline__
+#define _ELIDABLE_INLINE static __inline__
 #endif
 
 #endif /* _ANSIDECL_H_ */
